;   12 
.include	"tn2313def.inc"

;======================================================
.def	byte_0	= r2
.def	byte_1	= r3
.def	byte_2	= r4
.def	bin_h	= r5
.def	bin_l	= r6

.def	temp	= r16
.def	temp1	= r17
.def	temp2	= r18
.def	cnt	= r19
.def	smdl	= r20
.def	count	= r21
;----------------------------------------------------
.def	bitmap	= r22
;	0 -   (1)
;	1 -   (1)
;
;
;	7 -   (0)
;====================================================

;====================================================
.equ	XTAL		= 4000000
.equ 	baudrate = 9600 
.equ 	bauddivider = XTAL/(16*baudrate)-1
;====================================================
.equ	t_count		= 1000000/(XTAL/768)
.equ	t_smdl		= 100000000/(XTAL/3)
.equ	t_480h		= 480/t_count+1
.equ	t_480l		= 100*(480-(t_480h-1)*t_count)/t_smdl
.equ	t_70h		= 70/t_count+1
.equ	t_70l		= 100*(70-(t_70h-1)*t_count)/t_smdl
.equ	t_410h		= 410/t_count+1
.equ	t_410l		= 100*(410-(t_410h-1)*t_count)/t_smdl
.equ	t_55h		= 55/t_count+1
.equ	t_55l		= 100*(55-(t_55h-1)*t_count)/t_smdl
.equ	t_60h		= 60/t_count+1
.equ	t_60l		= 100*(60-(t_60h-1)*t_count)/t_smdl
.equ	t_64h		= 64/t_count+1
.equ	t_64l		= 100*(64-(t_64h-1)*t_count)/t_smdl
.equ	t_6			= 600/t_smdl
.equ	t_9			= 900/t_smdl
.equ	t_10		= 1000/t_smdl
;====================================================
.equ	t_ctc		= (XTAL/1024)*100/133
;====================================================
.equ	t_port		= PORTB
.equ	t_ddr		= DDRB
.equ	t_pin		= PINB
.equ	t_sens		= 0
;****************************************************

.dseg
;====================================================
t_data:		.byte	2
t_asc2:		.byte	$a
t_bitmap:	.byte	1
chan_1:		.byte	4
chan_2:		.byte	4
chan_3:		.byte	4
KelvinLow:	.byte	1	;       
KelvinHigh:	.byte	1

;====================================================

;PB0 -   
;PD6 -  
;PD4 -   
;PD3 -     
;PD5 -  3-   
;PD2 -  3-   

;****************************************************

	.cseg

	.org 0
		rjmp	reset

;*********   ***********************
reset:		ldi	temp1,	low(RAMEND)	;  Stack Pointer
		out	SPL,	temp1

		ldi	temp,0b11111100
		out	ddrd,temp
		clr r0		; 0
		
		rcall 	USART_Init		;  
	
;******   ************************
		clr	bitmap			;   
		sts	t_bitmap, bitmap

;      8 
;         

	;cli
	;wdr
	in temp, MCUSR
	andi temp, (0xff & (0<<WDRF) )	;   WDRF   MCUSR ( tiny2313)
	out MCUSR,temp

	ldi temp, (1<<WDCE) | (1<<WDE)
	out WDTCR,temp
	ldi temp, (0<<WDCE) | (1<<WDE) | (1<<WDP0) | (0<<WDP1) | (0<<WDP2) | (1<<WDP3)
	out WDTCR,temp
	;sei

	sei				;  
		
;++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++		
main:
wdr	;  
chan1:
;   
rcall dss
		lds bitmap, t_bitmap	;     
		sbrs bitmap, 0		;,     
		rjmp corrupt1
		rjmp ok1
corrupt1:		
	ldi temp,$39		;  "9",    
	sts chan_1,temp
	sts chan_1+1,temp
	sts chan_1+2,temp
	sts chan_1+3,temp
	rjmp chan2		; ,   
ok1:
rcall bcd_convert
		sts chan_1,r7
		sts chan_1+1,r8
		sts chan_1+2,r9
		sts chan_1+3,r10

chan2:
sbi portd,5			;  2-    
rcall delay100ms

;   
rcall dss
		lds	bitmap,	t_bitmap
		sbrs	bitmap,	0
		rjmp corrupt2
		rjmp ok2
corrupt2:		
	ldi temp,$39		;  "9",    
	sts chan_2,temp
	sts chan_2+1,temp
	sts chan_2+2,temp
	sts chan_2+3,temp
	rjmp chan3		; ,   
ok2:
rcall bcd_convert
		sts chan_2,r7
		sts chan_2+1,r8
		sts chan_2+2,r9
		sts chan_2+3,r10
chan3:
cbi portd,5			;  3-    
sbi portd,2
rcall delay100ms

;   
rcall dss
		lds	bitmap,	t_bitmap
		sbrs	bitmap,	0
		rjmp corrupt3
		rjmp ok3
corrupt3:		
	ldi temp,$39		;  "9",    
	sts chan_3,temp
	sts chan_3+1,temp
	sts chan_3+2,temp
	sts chan_3+3,temp
	
	;  
	mov r7, temp		; "9"
	mov r8, temp
	mov r9, temp
	mov r10, temp
	rcall convertK			;   
	
	rjmp finish2		; ,   
ok3:

rcall bcd_convert
		sts chan_3,r7
		sts chan_3+1,r8
		sts chan_3+2,r9
		sts chan_3+3,r10

		rcall convertK	;   

finish2:
cbi portd,2			;  1-      

;=======================================================================================================

;   1 
lds temp,chan_1
rcall USART_Transmit
lds temp,chan_1+1
rcall USART_Transmit
lds temp,chan_1+2
rcall USART_Transmit
ldi temp,$2e		;
rcall USART_Transmit
lds temp,chan_1+3
rcall USART_Transmit
ldi temp,$20
rcall USART_Transmit
ldi temp,$20
rcall USART_Transmit	; 

;   2 
lds temp,chan_2
rcall USART_Transmit
lds temp,chan_2+1
rcall USART_Transmit
lds temp,chan_2+2
rcall USART_Transmit
ldi temp,$2e		;
rcall USART_Transmit
lds temp,chan_2+3
rcall USART_Transmit
ldi temp,$20
rcall USART_Transmit
ldi temp,$20
rcall USART_Transmit	; 

;   3 
lds temp,chan_3
rcall USART_Transmit
lds temp,chan_3+1
rcall USART_Transmit
lds temp,chan_3+2
rcall USART_Transmit
ldi temp,$2e		;
rcall USART_Transmit
lds temp,chan_3+3
rcall USART_Transmit
ldi temp,$20
rcall USART_Transmit
ldi temp,$20
rcall USART_Transmit	; 

lds r19, KelvinLow	;low,     
lds r20, KelvinHigh			;high,      r19,r20
rcall convert		; HEX       r7,8,9,10

mov temp,r7
rcall USART_Transmit
mov temp,r8
rcall USART_Transmit
mov temp,r9
rcall USART_Transmit
mov temp,r10
rcall USART_Transmit
ldi temp,$20
rcall USART_Transmit
ldi temp,$20
rcall USART_Transmit	; 



ldi temp,$0d		; 
rcall USART_Transmit

wdr	;  

;====================================================================================================
		
;    

sbi portd,4		;  
rcall between	;600ms	 3 
rcall between	;600ms
rcall between	;600ms
rcall between	;600ms
rcall between	;600ms

sbi portd,3		;    
rcall between	;600ms	 1,2 	
rcall between	;600ms

wdr	;  
;=============================================================
ldi temp,200	;     20 
sbi portd,6	;   
sec20:
	rcall delay100ms
	wdr	;  
	dec temp
	brne sec20
cbi portd,6	;   
;============================================================

rcall between	;600ms	; 1,8 
rcall between	;600ms
rcall between	;600ms

wdr	;  
rcall beacon		;  

wdr	;  
rcall temp_out		;    3-  
wdr	;  
rcall between		;   = 600
wdr	;  

lds temp,chan_1
rcall decoder
wdr	;  
lds temp,chan_1+1
rcall decoder
wdr	;  
lds temp,chan_1+2
rcall decoder
wdr	;  
lds temp,chan_1+3
rcall decoder
wdr	;  

rcall between	;   = 600

lds temp,chan_1
rcall decoder
wdr	;  
lds temp,chan_1+1
rcall decoder
wdr	;  
lds temp,chan_1+2
rcall decoder
wdr	;  
lds temp,chan_1+3
rcall decoder
wdr	;  

rcall between	;   = 600
rcall separate	; - 
rcall between	;   = 600
wdr	;  

lds temp,chan_2
rcall decoder
wdr	;  
lds temp,chan_2+1
rcall decoder
wdr	;  
lds temp,chan_2+2
rcall decoder
wdr	;  
lds temp,chan_2+3
rcall decoder

rcall between	;   = 600
wdr	;  

lds temp,chan_2
rcall decoder
wdr	;  
lds temp,chan_2+1
rcall decoder
wdr	;  
lds temp,chan_2+2
rcall decoder
wdr	;  
lds temp,chan_2+3
rcall decoder
wdr	;  

rcall between	;   = 600
rcall separate	; - 
rcall between	;   = 600

wdr	;  
lds temp,chan_3
rcall decoder
wdr	;  
lds temp,chan_3+1
rcall decoder
wdr	;  
lds temp,chan_3+2
rcall decoder
wdr	;  
lds temp,chan_3+3
rcall decoder
wdr	;  

rcall between	;   = 600
rcall symb_K	; 
rcall delay100ms
wdr	;  

cbi portd,3		;    
rcall between	;600ms	;1,2s
rcall between	;600ms
wdr	;  

;============  ========================================================================
					;         
	lds	temp1, KelvinLow	;low	  3-  ()
	lds	temp2, KelvinHigh	;high
	
	ldi	r19, $47	;low
	ldi	r20, $0a	;high	263,1x10K	  -10  

	sub	temp1,	r19	;low
	sbc	temp2,	r20	;high
	brmi 	on_rx	;  

;===============================================================================================
off:
cbi portd,4		;  TRX

on_rx:

;  15 ,         2- 
wdr	;  

	ldi temp,15
big_delay:
	rcall delay60s
	dec temp
	brne big_delay
rjmp main

;=================================================================================================
; ,   



dss:
;-----   --------------------------------
		rcall	t_sc			;   pull_up
		rcall	t_res    		; \					exist
		sbrc	bitmap,	$7
		rjmp	no_sen
		ldi		temp1,	$CC 	;  ROM-
		rcall	w_term		  	;  						write_byte
;-----    -------------------
st_cnv:	rcall	t_res			;									exist
		ldi		temp1,	$CC     ;  ROM-
		rcall	w_term			;  						write_byte
		ldi		temp1,	$44     ;   
		rcall	w_term			;  						write_byte
		sbi		t_ddr,	t_sens  ;         ( pull_up)
		sbi		t_port,	t_sens


;-----    ----------------
; ============================= 
;    delay loop generator 
;     3000000 cycles:
; ----------------------------- 
; delaying 2999856 cycles:
          ldi  R21, $10
WGLOOP0_:  ldi  R22, $F8
WGLOOP1_:  ldi  R23, $FB
WGLOOP2_:  dec  R23
          brne WGLOOP2_
          dec  R22
          brne WGLOOP1_
          dec  R21
          brne WGLOOP0_
; ----------------------------- 
; delaying 144 cycles:
          ldi  R21, $30
WGLOOP3_:  dec  R21
          brne WGLOOP3_
; ============================= 


;-----   --------------------------------
		rcall	t_sc			;   pull_up
		rcall	t_res    		; \					exist
		ldi		temp1,	$CC 	;  ROM-
		rcall	w_term		  	;  						write_byte
		ldi		temp1,	$BE 	;  SRAM
		rcall	w_term		   	;  						write_byte
		rcall	r_term	    	;    	read_byte
		mov		temp2,	temp1
		rcall	r_term	    	;    		read_byte
;-----   -------------------------
		cbr		bitmap,	$2
		mov		count,	temp2
		mov		smdl,	temp1
		andi	temp1,	$f		;    
		andi	temp2,	$f0		;   \ 
		or		temp2,	temp1	;   
		swap	temp2
		sbrs	smdl,	$7		;  
		rjmp	datapl
;-----   "-" ------------------------------
		sbr		bitmap,	$2
		swap	count
		andi	count,	$f0		;   
		ldi		temp1,	$0
		sub		temp1,	count
		mov		count,	temp1
		ldi		temp1,	$0
		sbc		temp1,	temp2
		mov		temp2,	temp1
		swap	count
		sbr		temp2,	$80
datapl:	sts		t_data,	temp2
		andi	count,	$f		;   
		sts		t_data+1, count	;     ""
		sbr		bitmap,	$1		;  

;================================
no_sen:	
	sts		t_bitmap, bitmap
ret


bcd_convert:
;****************************************************
;		   :)
;****************************************************
		lds		bitmap,	t_bitmap
		sbrs	bitmap,	$0
		rjmp	main
		cbr		bitmap,	$1			;   
		sts		t_bitmap, bitmap
		clr		bin_h
		lds		temp1,	t_data
		mov		cnt,	temp1
		andi	temp1,	$7f
		mov		bin_l,	temp1
		rcall	c2to10
		ldi		YL,		low(t_asc2)
		ldi		YH,		high(t_asc2)
;-----   -----------------------------------
		ldi		temp1,	$20
		sbrc	cnt,	$7
		ldi		temp1,	'-'							; 2D
		st		Y+,		temp1						;1
		mov		r7,		temp1
;-----   ----------------------------------
		ldi		temp1,	$20
		mov		temp2,	byte_1
		andi	temp2,	$f
		breq	d10_3
		mov		temp1,	temp2
		ori		temp1,	$30
d10_3:	st		Y+,		temp1						;2
;-----   --------------------------------
		ldi		temp1,	$20
		mov		temp2,	byte_0
		andi	temp2,	$f0
		brne	d10n2
		tst		byte_1
		breq	d10_2
d10n2:	mov		temp1,	temp2
		swap	temp1
		ori		temp1,	$30
d10_2:	st		Y+,		temp1						;3
		mov		r8,		temp1
;-----   -------------------------------
		mov		temp1,	byte_0
		andi	temp1,	$f
		ori		temp1,	$30
		st		Y+,		temp1						;4
		mov		r9,		temp1
;-----    -----------------------
		ldi		temp1,	'.'
		st		Y+,		temp1						;5
;-----      --------------
		lds		count,	t_data+1
		tst		count
		breq	no_inc
		sbrc	bitmap,	$1
		inc		count
no_inc:	clr		temp1
		clr		temp2
binstr:	tst		count
		breq	binend
		subi	temp1,	$8f
		sbci	temp2,	$fd
		dec		count
		rjmp	binstr
binend:	mov		bin_l,	temp1
		mov		bin_h,	temp2
		rcall	c2to10
		mov		temp1,	byte_1
		andi	temp1,	$f0
		swap	temp1
		ori		temp1,	$30
		st		Y+,		temp1						;6
		mov		r10,	temp1
ret
;****************************************************



;******   *******************************
t_res:	rcall	t_sc
;---------- 480 uS ----------------------------------
		ldi		count,	t_480h
		ldi		smdl,	t_480l
		rcall	sm_d0
		rcall	t_cs
;---------- 70 uS -----------------------------------
		ldi		count,	t_70h
		ldi		smdl,	t_70l
		rcall	sm_d0
		sbr		bitmap,	$80
		sbis	t_pin,	t_sens
		cbr		bitmap,	$80
;---------- 410 uS ----------------------------------
		ldi		count,	t_410h
		ldi		smdl,	t_410l
		rcall	sm_d0
		ret
;******  ************************************
sm_del:	ldi		count,	$1
		nop
sm_d0:	dec		smdl
		brne	sm_d0
		dec		count
		brne	sm_d0
		ret
;******  1-Ware *******************************
w_term:	sec
        ror		temp1 
        rjmp	w_frst
;------   "temp"   -----------
w_bit:  lsr		temp1       
w_frst: breq	w_end
        brcc	w_bit0
;------  "1" -----------------------------------
		rcall	t_sc
		ldi		smdl,	t_6		; 6 uS
		rcall	sm_del
		rcall	t_cs
		ldi		count,	t_64h	; 64 uS
		ldi		smdl,	t_64l
		rcall	sm_d0
        rjmp	w_bit
;------  "0" -----------------------------------
w_bit0:	rcall	t_sc
		ldi		count,	t_60h	; 60 uS
		ldi		smdl,	t_60l
		rcall	sm_d0
		rcall	t_cs
		ldi		smdl,	t_10	; 10 uS
		rcall	sm_del
		rjmp	w_bit
w_end:	ret
;******  1-Ware *******************************
r_term:	ldi		cnt,	$8
r_bit:	rcall	t_sc
		ldi		smdl,	t_6		; 6 uS
		rcall	sm_del
		rcall	t_cs
		ldi		smdl,	t_9		; 9 uS
		rcall	sm_del
		clc
		sbic	t_pin,	t_sens
		sec
		ror		temp1
		ldi		count,	t_55h	; 55 uS
		ldi		smdl,	t_55l
		rcall	sm_d0
		dec		cnt
		brne	r_bit
		ret
;******    pull-up 1-Ware *********
t_sc:	sbi		t_ddr,	t_sens
		cbi		t_port,	t_sens
		ret
;----------------------------------------------------
t_cs:   cbi		t_ddr,	t_sens
		sbi		t_port,	t_sens
		ret
;****************************************************
; bin2BCD16
;****************************************************
c2to10:	ldi		count,	$10
		clr		byte_0
		clr		byte_1
		clr		byte_2
		clr		ZH
loop_b:	lsl		bin_l
		rol		bin_h
		rol		byte_0
		rol		byte_1
		rol		byte_2
		dec		count
		brne	nm1
		ret
nm1:	ldi		ZL,		$5
nm2:	ld		smdl,	-Z
		ldi		temp1,	$03
		add		smdl,	temp1
		sbrc	smdl,	3
		st		Z,		smdl
		ld		smdl,	Z
		ldi		temp1,	$30
		add		smdl,	temp1
		sbrc	smdl,	7
		st		Z,		smdl
		cpi		ZL,		$2
		brne	nm2
		rjmp	loop_b
;****************************************************


;**************    100  (fclk-4000khz) *******
; ============================= 
;    delay loop generator 
;     400000 cycles:
; ----------------------------- 
; delaying 399999 cycles:
delay100ms:
          ldi  R17, $97
WGLOOP000:  ldi  R18, $06
WGLOOP111:  ldi  R19, $92
WGLOOP222:  dec  R19
          brne WGLOOP222
          dec  R18
          brne WGLOOP111
          dec  R17
          brne WGLOOP000
; ----------------------------- 
; delaying 1 cycle:
          nop
ret
; ============================= 

;**********************************************************
tochka:			; (100ms 6wpm)
	sbi portd,6	;   
	rcall delay100ms
	cbi portd,6	;   
	rcall delay100ms;(100ms 6 wpm)
	ret
	
;**********************************************************
tire:			; (300ms 6wpm)
	sbi portd,6	;   
	rcall delay100ms
	rcall delay100ms
	rcall delay100ms
	cbi portd,6;   
	rcall delay100ms;(100ms 6 wpm)
	ret
	
;***********************************************************
space:			;  (200ms 6wpm)
	rcall delay100ms
	rcall delay100ms
	ret
	
;**************************
decoder:
	cpi temp,$30
	breq num_0
	cpi temp,$31
	breq num_1
	cpi temp,$32
	breq num_2
	cpi temp,$33
	breq num_3
	cpi temp,$34
	breq num_4
	cpi temp,$35
	breq num_5
	cpi temp,$36
	breq num_6
	cpi temp,$37
	breq num_7
	cpi temp,$38
	breq num_8
		
	rjmp finish 
	
num_0:	rcall tire	;0
	rcall tire
	rcall tire
	rcall tire
	rcall tire
	rcall space
	rjmp finish
	
num_1:	rcall tochka	;1
	rcall tire
	rcall tire
	rcall tire
	rcall tire
	rcall space
	rjmp finish
	
num_2:	rcall tochka	;2
	rcall tochka
	rcall tire
	rcall tire
	rcall tire
	rcall space
	rjmp finish
	
num_3:	rcall tochka	;3
	rcall tochka
	rcall tochka
	rcall tire
	rcall tire
	rcall space
	rjmp finish
	
num_4:	rcall tochka	;4
	rcall tochka
	rcall tochka
	rcall tochka
	rcall tire
	rcall space
	rjmp finish
	
num_5:	rcall tochka	;5
	rcall tochka
	rcall tochka
	rcall tochka
	rcall tochka
	rcall space
	rjmp finish		
	
num_6:	rcall tire	;6
	rcall tochka
	rcall tochka
	rcall tochka
	rcall tochka
	rcall space
	rjmp finish
	
num_7:	rcall tire	;7
	rcall tire
	rcall tochka
	rcall tochka
	rcall tochka
	rcall space
	rjmp finish
	
num_8:	rcall tire	;8
	rcall tire
	rcall tire
	rcall tochka
	rcall tochka
	rcall space
	rjmp finish
	
;***************************************  *******************
finish:
	cpi temp,$39
	breq num_9
	cpi temp,$2d
	breq m
	cpi temp,$20
	breq zero
	rjmp finish1
	
num_9:	rcall tire	;9
	rcall tire
	rcall tire
	rcall tire
	rcall tochka
	rcall space
	rjmp finish1
	
m:	rcall tire		;$2D
	rcall tire
	rcall space
	rjmp finish1

zero:
	rcall tire		;0
	rcall tire
	rcall tire
	rcall tire
	rcall tire
	rcall space
	
finish1:
ret


;******************************************************************
between:		;   600ms
	rcall delay100ms
	rcall delay100ms
	rcall delay100ms
	rcall delay100ms
	rcall delay100ms
	rcall delay100ms
	ret
	
;********************************
beacon:
	rcall symb_U
	rcall symb_A
	wdr	;  
	rcall num3
	rcall symb_V
	rcall symb_V
	wdr	;  
	rcall symb_M
	rcall slash	;/
	rcall symb_B
	wdr	;  
	rcall between	;   = 600
	rcall symb_L
	wdr	;  
	rcall symb_O
	rcall num_0
	wdr	;  
	rcall symb_6
	rcall symb_A
	wdr	;  
	rcall symb_C
	rcall between	;   = 600
ret

temp_out:
	rcall symb_T
	rcall symb_E
	rcall symb_M
	rcall symb_P
	ret

;=====================================================
;      	 
symb_U:	rcall tochka	;$55
	rcall tochka
	rcall tire
	rcall space
	ret

symb_A:	rcall tochka	;$41
	rcall tire
	rcall space
	ret

num3:	rcall tochka	;$33
	rcall tochka
	rcall tochka
	rcall tire
	rcall tire
	rcall space
	ret

symb_V:	rcall tochka	;$56
	rcall tochka
	rcall tochka
	rcall tire
	rcall space
	ret
	
symb_M:	rcall tire	;$2D
	rcall tire
	rcall space
	ret
	
slash:			;/
	rcall tire
	rcall tochka
	rcall tochka
	rcall tire
	rcall tochka
	rcall space
	ret
	
symb_B:	rcall tire	;$42
	rcall tochka
	rcall tochka
	rcall tochka
	rcall space
	ret
	
symb_L:	rcall tochka	;$4C
	rcall tire
	rcall tochka
	rcall tochka
	rcall space
	ret
	
symb_O:	rcall tire	;$4F
	rcall tire
	rcall tire
	rcall space
	ret
	
symb_6:	rcall tire	;$36
	rcall tochka
	rcall tochka
	rcall tochka
	rcall tochka
	rcall space
	ret

symb_C:	rcall tire	;$43
	rcall tochka
	rcall tire
	rcall tochka
	rcall space
	ret
	
symb_K:	rcall tire
	rcall tochka
	rcall tire
	rcall space
	ret
	
symb_T:	rcall tire
	rcall space
	ret
	
symb_E:	rcall tochka
	rcall space
	ret

symb_P:	rcall tochka
	rcall tire
	rcall tire
	rcall tochka
	rcall space
	ret

;=====================
separate:
	rcall tire
	rcall tochka
	rcall tochka
	rcall tochka
	rcall tire
	rcall space
	
	rcall between	;   = 600
ret


;  60     4 
; ============================= 
;    delay loop generator 
;     240000000 cycles:
; ----------------------------- 
; delaying 49939965 cycles:
delay60s:
          ldi  R17, $FF
WGLOOP0:  ldi  R18, $FF
WGLOOP1:  ldi  R19, $FF
WGLOOP2:  dec  R19
          brne WGLOOP2
          wdr	;  
          dec  R18
          brne WGLOOP1
          wdr	;  
          dec  R17
          brne WGLOOP0
          wdr	;  
; ----------------------------- 
; delaying 49939965 cycles:
          ldi  R17, $FF
WGLOOP3:  ldi  R18, $FF
WGLOOP4:  ldi  R19, $FF
WGLOOP5:  dec  R19
          brne WGLOOP5
          wdr	;  
          dec  R18
          brne WGLOOP4
          wdr	;  
          dec  R17
          brne WGLOOP3
          wdr	;  
; ----------------------------- 
; delaying 49939965 cycles:
          ldi  R17, $FF
WGLOOP6:  ldi  R18, $FF
WGLOOP7:  ldi  R19, $FF
WGLOOP8:  dec  R19
          brne WGLOOP8
          wdr	;  
          dec  R18
          brne WGLOOP7
          wdr	;  
          dec  R17
          brne WGLOOP6
          wdr	;  
; ----------------------------- 
; delaying 49939965 cycles:
          ldi  R17, $FF
WGLOOP9:  ldi  R18, $FF
WGLOOP10: ldi  R19, $FF
WGLOOP11: dec  R19
          brne WGLOOP11
          wdr	;  
          dec  R18
          brne WGLOOP10
          wdr	;  
          dec  R17
          brne WGLOOP9
          wdr	;  
; ----------------------------- 
; delaying 40239780 cycles:
          ldi  R17, $F5
WGLOOP12: ldi  R18, $E7
WGLOOP13: ldi  R19, $EC
WGLOOP14: dec  R19
          brne WGLOOP14
          wdr	;  
          dec  R18
          brne WGLOOP13
          wdr	;  
          dec  R17
          brne WGLOOP12
          wdr	;  
; ----------------------------- 
; delaying 360 cycles:
          ldi  R17, $78
WGLOOP15: dec  R17
          brne WGLOOP15
          wdr	;  
ret
; ============================= 


; ============================= 
;    delay loop generator 
;     20000000 cycles: 5 sec
; ----------------------------- 
; delaying 19999992 cycles:
delay5sec:
          ldi  R17, $BF
WGLOOP_0:  ldi  R18, $A7
WGLOOP_1:  ldi  R19, $D0
WGLOOP_2:  dec  R19
          brne WGLOOP_2
          dec  R18
          brne WGLOOP_1
          dec  R17
          brne WGLOOP_0
; ----------------------------- 
; delaying 6 cycles:
          ldi  R17, $02
WGLOOP_3:  dec  R17
          brne WGLOOP_3
; ----------------------------- 
; delaying 2 cycles:
          nop
          nop
ret

;===============================================================================================
convertK:
push temp	;    
push temp1
push temp2
	
	ldi temp,$30	;      
	sub r8,temp
	sub r9,temp
	sub r10,temp

	push	r9	;   R9    ( )
	
	mov temp,r8	;   
	clr r8		; R8 low K
	clr r9		; R9 high K
a:
	dec temp
	brmi aaa
	ldi temp1,100
	add r8,temp1	;low
	adc r9,r0	;high     
	rjmp a
aaa:	
	pop temp	;   
b:	
	dec temp
	brmi bbb
	ldi temp1,10
	add r8,temp1	;low
	adc r9,r0	;high        
	rjmp b
bbb:	
	add r8,r10	;low K	++ r8r9
	adc r9,r0	;high K
	
	ldi temp1, $ab	;low	273,1Kx10
	ldi temp2, $0a	;high
	
	ldi temp,$2d	; "-"
	cp r7,temp
	breq minus
plus:	
	add temp1, r8	;low K
	adc temp2, r9	;high K
	sts KelvinLow, temp1	;  RAM
	sts KelvinHigh, temp2
	rjmp d
minus:
	sub temp1,r8	;low
	sbc temp2,r9	;high
	sts KelvinLow,temp1	;  RAM
	sts KelvinHigh,temp2
d:
pop temp2	;  
pop temp1
pop temp
ret


;++++++++++++++++++++++++++++++++++++
USART_Init:
; Set baud rate
ldi temp, low(bauddivider)	;9600 b/s
out UBRRL, temp
ldi temp, high(bauddivider)
out UBRRH, temp
;  , , 
ldi temp, (1<<TXEN) | (1<<RXEN)
out UCSRB,temp
; Set frame format: 8data, 2stop bit
ldi temp, (1<<USBS)|(3<<UCSZ0)
out UCSRC,temp
ret

;++++++++++++++++++++++++++++++++++
USART_Transmit:
; Wait for empty transmit buffer
sbis UCSRA,UDRE
rjmp USART_Transmit
; Put data (r16) into buffer, sends the data
out UDR,temp
ret



;=======================================================================

;=========================================================	
convert:
	push temp
	push temp1
	push r25
	push r19
	push r20
;;;;;        ;;;;;;;;;;;;;;
	ldi temp,$E8	   ;low 3 
        ldi temp1,$03      ;high :1000= 03 E8h
        rcall delen
        mov r7,r25	   ;  R7    #4
        ldi temp,$30
        add r7,temp	   	
	
	ldi temp,$64	   ;low 3 
        ldi temp1,$00      ;high :100= 00 64h
        rcall delen
        mov r8,r25	   ;  R8    #3
        ldi temp,$30
        add r8,temp
           
        ldi temp,$0A	   ;low
        ldi temp1,$00        ;high 2 
        rcall delen	   ; :10= 00 0Ah
        mov r9,r25	   ;  R9    #2
        ldi temp,$30
        add r9,temp
         
        mov r10,r19	   ; 1 
         		   ;  R10    #1
        ldi temp,$30
        add r10,temp
        ; 
        ;R7 - 0/ 
        ;R8 -  
        ;R9 -  
        ;R10 -   

pop r20
pop r19
pop r25
pop temp1
pop temp
ret

;**********************************************************
; 
delen:
	 ldi r25, -1
SUBii:   inc r25
         sub r19,temp        ; low
         sbc r20,temp1	     ; high
         brsh SUBi1          ;   > 0
         add r19,temp        ; low
         adc r20,temp1       ; high
         ret
SUBi1:
         rjmp SUBii
ret




